USE [BDHIS_MINSA] -- ====>>>>>>>> NOMBRE DE LA BASE DE DATOS DEBE SER REEMPLAZO POR EL DE USTEDES
GO
PRINT '=================>>>>>>>>> INICIO DE PROCESO MJM_3_SCRIPT_VISTAS_TABLAS_MAESTRAS_ARCHIVOS_PLANOS_DETALLADO <<<<<<<<<================='
GO
IF OBJECT_ID('[dbo].[TRAMA_BASE_GENERALES_RPT_02_MORBILIDAD_CONSOLIDADO]', 'U') IS NOT NULL
BEGIN
	DROP TABLE TRAMA_BASE_GENERALES_RPT_02_MORBILIDAD_CONSOLIDADO
	PRINT 'SE ELIMINO LA TABLA TRAMA_BASE_GENERALES_RPT_02_MORBILIDAD_CONSOLIDADO'
END
GO
CREATE TABLE [dbo].[TRAMA_BASE_GENERALES_RPT_02_MORBILIDAD_CONSOLIDADO](
	[Codigo_Sector] [int] NULL,
	[Descripcion_Sector] [varchar](50) NULL,
	[Codigo_Disa] [int] NULL,
	[Descripcion_Disa] [varchar](80) NULL,
	[Codigo_Red] [char](2) NULL,
	[Descripcion_Red] [varchar](70) NULL,
	[Codigo_MicroRed] [char](2) NULL,
	[Descripcion_MicroRed] [varchar](70) NULL,
	[Codigo_Unico] [varchar](9) NULL,
	[Nombre_Establecimiento] [varchar](100) NULL,
	[Ubigueo_Establecimiento] [char](6) NULL,
	[Departamento_Establecimiento] [varchar](150) NULL,
	[Provincia_Establecimiento] [varchar](150) NULL,
	[Distrito_Establecimiento] [varchar](150) NULL,
	[Anio_Mes] [VARCHAR](8) NOT NULL,
	[Grupo_Edad] [VARCHAR](16) NOT NULL,
	[Genero] [CHAR](1) NOT NULL,
	[Id_Etnia] [CHAR](2) NOT NULL,
	[Descripcion_Etnia] [varchar](100) NULL,
	[Id_Financiador] [INT] NOT NULL,
	[Descripcion_Financiador] [varchar](100) NULL,
	[Id_Ups] [VARCHAR](6) NOT NULL,
	[Descripcion_Ups] [varchar](100) NULL,
	[Id_Profesion] [VARCHAR](2) NOT NULL,
	[Codigo_Item] [VARCHAR](10) NOT NULL,
	[Descripcion_Item] [varchar](300) NULL,
	[Casos] [INT] NOT NULL
) ON [PRIMARY]
GO
PRINT 'SE CREO LA TABLA TRAMA_BASE_GENERALES_RPT_02_MORBILIDAD_CONSOLIDADO'
GO
INSERT INTO TRAMA_BASE_GENERALES_RPT_02_MORBILIDAD_CONSOLIDADO
SELECT
	B.Codigo_Sector,
	B.Descripcion_Sector,
	B.Codigo_Disa,
	B.Descripcion_Disa,
	B.Codigo_Red,
	B.Descripcion_Red,
	B.Codigo_MicroRed,
	B.Descripcion_MicroRed,
	B.Codigo_Unico,
	B.Nombre_Establecimiento,
	B.Ubigueo_Establecimiento,
	B.Departamento_Establecimiento,
	B.Provincia_Establecimiento,
	B.Distrito_Establecimiento,
	B.Anio_Mes,
	B.Grupo_Edad,
	B.Genero,
	B.Id_Etnia,
	B.Descripcion_Etnia,
	B.Id_Financiador,
	B.Descripcion_Financiador,
	B.Id_Ups,
	B.Descripcion_Ups,
	B.Id_Profesion,
	B.Codigo_Item,
	B.Descripcion_Item,
	COUNT(*) Casos
FROM
	(SELECT 
		A.Codigo_Sector,
		A.Descripcion_Sector,
		A.Codigo_Disa,
		A.Descripcion_Disa,
		A.Codigo_Red,
		A.Descripcion_Red,
		A.Codigo_MicroRed,
		A.Descripcion_MicroRed,
		A.Codigo_Unico,
		A.Nombre_Establecimiento,
		A.Ubigueo_Establecimiento,
		A.Departamento_Establecimiento,
		A.Provincia_Establecimiento,
		A.Distrito_Establecimiento,
		A.Anio_Mes,
		A.Grupo_Edad,
		A.Genero,
		A.Id_Etnia,
		A.Descripcion_Etnia,
		A.Id_Financiador,
		A.Descripcion_Financiador,
		A.Id_Ups,
		A.Descripcion_Ups,
		A.Id_Profesion,
		A.Codigo_Item,
		A.Descripcion_Item,
		ROW_NUMBER() OVER (PARTITION BY A.Id_Cita, A.Codigo_Item ORDER BY A.Id_Cita, A.Codigo_Item, A.Id_Correlativo_Item) Num
	FROM T_CONSOLIDADO_NUEVA_TRAMA_HISMINSA A
	WHERE	A.Fg_Tipo='CX' AND
			A.Tipo_Diagnostico='D' AND
			NOT SUBSTRING(A.Codigo_Item,1,1) IN ('U','Z')	AND
			A.Codigo_Item<>'9999' AND
			A.Genero IS NOT NULL AND
			A.Grupo_Edad IS NOT NULL) B 
WHERE B.Num=1
GROUP BY
	B.Codigo_Sector,
	B.Descripcion_Sector,
	B.Codigo_Disa,
	B.Descripcion_Disa,
	B.Codigo_Red,
	B.Descripcion_Red,
	B.Codigo_MicroRed,
	B.Descripcion_MicroRed,
	B.Codigo_Unico,
	B.Nombre_Establecimiento,
	B.Ubigueo_Establecimiento,
	B.Departamento_Establecimiento,
	B.Provincia_Establecimiento,
	B.Distrito_Establecimiento,
	B.Anio_Mes,
	B.Grupo_Edad,
	B.Genero,
	B.Id_Etnia,
	B.Descripcion_Etnia,
	B.Id_Financiador,
	B.Descripcion_Financiador,
	B.Id_Ups,
	B.Descripcion_Ups,
	B.Id_Profesion,
	B.Codigo_Item,
	B.Descripcion_Item
GO
PRINT 'SE INSERTO INFORMACION TRAMA_BASE_GENERALES_RPT_02_MORBILIDAD_CONSOLIDADO'
GO
PRINT '=================>>>>>>>>> FIN DE PROCESO MJM_5_SCRIPT_REPORTES_OPERACIONALES <<<<<<<<<================='